;=====================================================================
;                       PCTOOLS 98 PLUGINS SDK
;                (c) Benoit SCHERRER, NeXO Software
;
;---------------------------------------------------------------------
; PLUGINS SDK VERSION   : 1.00
; FILE DESCRIPTION      : Library Information Plugin
;=====================================================================

	include "api92.h"

	xdef    _main                   ;normal assembly program
	xdef    _comment

	include "pctplug.h"             ;and after we include pctplug.h

ENTRYHDL	equ 10

;--------------------------------------------------------------------
; Start of PCTOOLS 98 plugin
;--------------------------------------------------------------------

	PRG_AS_PLUGIN

sp_ext  dc.b    PRGMFUNC_ID          	;specific extension ?
export  dc.b    %00000100               ;export flag byte

	dc.l    NOT_USED         	;1:Initialization of PCT98
	dc.l    NOT_USED                ;2:End of PCT98
	dc.l    KeyPressed             	;3:Key pressed
	dc.l    NOT_USED                ;4:ENTER pressed
	dc.l    NOT_USED            	;5:Cursor moved
	dc.l    NOT_USED                ;6:Show Item

END_PLUGIN_TABLE:
	;(...)                          the program can continue

	rts

;---------------------------------------------------------------------
; Function called when a key is pressed in PCT98
;
; Notice that this function will be execute only if PCT98
; itself doesn't already use this keycode.
;
; USE SPECIFIC EXTENSION
;
;Input> rg1.w : Value of keycode
;       rg2.l : Address of the current item (VAT entry)
;		selected. (from a buffer)
;       rg3.l : Address of the current VAT list buffer
;Out>
;
;RETURN> REDRAW_SCREEN : request to redraw the screen
;	 SHOW_MESSAGE : request to print a message in the
;	  status bar. The message is pointed by rg2 and must
;	  be valid
;---------------------------------------------------------------------
KeyPressed:
	cmp.w	#273,rg1+2		;Test if [F6]
	beq.s	\validkey		;
\exiterr rtplugin 0

\validkey
	move.l	rg2,a2
	move.w	ENTRYHDL(a2),d0		;Handle of selected file
	jsr	api92::DEREFd0a0

	lea	2(a0),a3		;Check if Fargo2 Program
	cmp.l	#$00324558,(a3)+
	bne.s	\exiterr
	cmp.w	#$4520,(a3)
	bne.s	\exiterr

	move.l	a0,a1
	adda.w	$12(a1),a0
	move.w	(a0)+,d2		;Number of libraries
	beq.s	\exiterr		;if null exit
	subq.w	#1,d2
	adda.w	(a0),a1			;Addr of first lib
	
	lea	WinData(PC),a0		;If succeed draw a nice Window
	jsr	api92::DrawWindow

	move.l	a1,a0			;save a1 For ListView
	move.l	a2,a1			;for DrawStringSpecial
	moveq.w	#90,d0
	moveq.w	#35,d1
	jsr	api92::DrawStringSpecial

;Use the ListView component of Api92. It is a very powerful and easy-to-use
;component to draw lists with scrolling if needed

	lea	ListViewData(PC),a2
	lea	CallBackKey(PC),a1	;Function which process Keys pressed
	move.w	d2,(a2)			;Put NbItem
	jsr	api92::ListView2

\exit  	rtplugin REDRAW_SCREEN

CallBackKey:
	moveq.w	#1,d0			;always exit if the
	rts				;user press a key

;====================================================================
; Plugin Data
;====================================================================
ListViewData:
		dc.w	0		;NbItem
		dc.b	94		;X
		dc.b	45		;Y
		dc.b	4		;NbItemPerPage-1
		dc.b	0		;Flag
		dc.b	8		;ListWidth
		dc.b	0		;ItemSize
WinData:
		dc.b	80,25,160,95
		dc.b	"Libraries Used :",0	
_comment
	dc.b    "LibInfo PCT98 Plugin",0

	end
