;=====================================================================
;                       PCTOOLS 98 PLUGINS SDK
;                (c) Benoit SCHERRER, NeXO Software
;
;---------------------------------------------------------------------
; PLUGINS SDK VERSION   : 1.00
; FILE DESCRIPTION      : include file
;=====================================================================


;---------------------------------------------------------------------
; CONSTANTS DECLARATION
;---------------------------------------------------------------------
MAX_FCT_PLUGIN  EQU     6
NOT_USED        EQU     0

PRGMFUNC_ID     EQU     $DC
MATLIST_ID      EQU     $D9
TEXT_ID         EQU     $E0
STR_ID          EQU     $2D
PIC_ID          EQU     $DF
MACR_ID         EQU     $E2
GDB_ID          EQU     $DE
FIG_ID          EQU     $E1
DATA_ID         EQU     $DD
ASM_ID		EQU	$F3	;only TI92+

;GENERAL RETURNS IN rg1
SKIP_PCTPROCESS	EQU	1	;bit 0=request to skip the pct process
REDRAW_SCREEN	EQU	2	;bit 1=redraw the screen
SHOW_MESSAGE	EQU	4	;bit 2=show message (rg3)
SKIP_NEXTPLUGINS EQU 	8	;bit 3

;---------------------------------------------------------------------
; Macro to insert at the beginning of a PCT98 plugin
;---------------------------------------------------------------------
PRG_AS_PLUGIN   MACRO
_main:
	bra.s   \skip
	dc.b    "PLUG"                  ;signatur
\skip   
PLGJp:  move.w  fctnum,d0       
	beq.s   \nojump

	clr.w   fctnum                  ;clear it for next call
	lsl.w   #2,d0
	lea     sp_ext-2(PC),a0
	move.l  0(a0,d0.w),a0
	jmp     (a0)

\nojump bra.s   END_PLUGIN_TABLE        ;jump to the end of the table


fctnum  dc.w    0

rg1     dc.l    0                       ;registers which with
rg2     dc.l    0                       ;PCT98 can pass 
rg3     dc.l    0                       ;parameters

	dc.w    MAX_FCT_PLUGIN          ;allow identification of plugin support version
	
		ENDM


;---------------------------------------------------------------------
; Macro to call to exit a PCT98 plugin function
;---------------------------------------------------------------------
rtplugin        MACRO
	move.l 	#\1,rg1          ;return value
	rts
		ENDM

