;=====================================================================
;                       PCTOOLS 98 PLUGINS SDK
;                (c) Benoit SCHERRER, NeXO Software
;
;---------------------------------------------------------------------
; PLUGINS SDK VERSION   : 1.00
; FILE DESCRIPTION      : Text Viewer Plugin
;=====================================================================

	include "tios.h"                ;library includes files
	include "flib.h"

	xdef    _main                   ;normal assembly program
	xdef    _comment

	include "pctplug.h"             ;and after we include pctplug.h

ENTRYHDL	equ	10

;--------------------------------------------------------------------
; Start of PCTOOLS 98 plugin
;--------------------------------------------------------------------

	PRG_AS_PLUGIN

sp_ext  dc.b    TEXT_ID                	;specific extension ?
export  dc.b    %00010000               ;export flag byte

	dc.l    NOT_USED         	;1:Initialization of PCT98
	dc.l    NOT_USED                ;2:End of PCT98
	dc.l    NOT_USED              	;3:Key pressed
	dc.l    NOT_USED                ;4:ENTER pressed
	dc.l    CursorMoved            	;5:Cursor moved
	dc.l    NOT_USED                ;6:Show Item

END_PLUGIN_TABLE:
	;(...)                          the program can continue
	rts

;---------------------------------------------------------------------
; Function called when the cursor is moved to a new item
;
; USE SPECIFIC EXTENSION
;
;Input>	rg2.l : Address of the current item (VAT entry)
;		selected. (from a buffer)
;Out>
;
;RETURN> SHOW_MESSAGE : request to print a message in the
;	  status bar. The message is pointed by rg2 and must
;	  be valid
;	 SKIP_PCTPROCESS : request that PCT98 don't print something
;	  in the status bar
;---------------------------------------------------------------------
CursorMoved:
	move.l	rg2,a1			;address of selected item
	move.w	ENTRYHDL(a1),d0		;Handle of selected item
	tios::DEREF d0,a0		;Get its address
	addq.l	#5,a0			;skip 5 first bytes

	lea	-600(a7),a1		;Address where put message
	move.l	a1,rg2			;and put it now in rg2

	clr.w	d2			;Number of copied chars
\cpy	move.b	(a0)+,(a1)+		;Copy char
	addq.w	#1,d2			;increment char count
	cmp.w	#65,d2			;if max
	beq.s	\toobig			;then go at \toobig
	tst.b	(a0)			;if end of string exit loop
	beq.s	\skip			
	cmp.b	#$0D,(a0)
	beq.s	\skip
	bra.s	\cpy

\toobig	subq.l	#3,a1			;if too big 
	move.b	#'.',(a1)+		;put '...'
	move.b	#'.',(a1)+
	move.b	#'.',(a1)+

\skip	clr.b	(a1)+			;and put 0x00 at the end of the string

	rtplugin (SHOW_MESSAGE+SKIP_PCTPROCESS)

;====================================================================
; Plugin Data
;====================================================================
_comment
	dc.b    "TxtViewer PCT98 Plugin",0
	end
